#include <stdint.h>

uint8_t uv2_get_8bit(uint8_t reg)
{
        uint8_t temp = 0;
        I2C1_Start();
        I2C1_Wr(0x20);
        I2C1_Wr(reg);
        I2C1_Repeated_Start();
        I2C1_Wr(0x21);
        temp = I2C1_Rd(0);
        I2C1_Stop();
}

uint16_t uv2_get_16bit (uint8_t reg)
{
        uint8_t temp[2] = {0};
        uint16_t retval = 0;

        I2C1_Start();
        I2C1_Wr(0x20);
        I2C1_Wr(reg);
        I2C1_Repeated_Start();
        I2C1_Wr(0x21);
        temp[0] = I2C1_Rd(0);
        temp[1] = I2C1_Rd(0);

        retval = (uint16_t) temp[0];
        retval |= ((uint16_t) temp[1]) << 8;
        I2C1_Stop();

        return retval;
}

float get_uv_index()
{
         float UVA = 0.0;
         float UVB = 0.0;
         float UVcomp1 = 0.0;
         float UVcomp2 = 0.0;
         float UVD = 0.0;
         float UVAcomp = 0.0;
         float UVBcomp = 0.0;
         float UVI = 0.0;
         float UVAresp = 0.0011;
         float UVBresp = 0.00125;

         float a = 3.33;
         float b = 2.5;
         float c = 3.66;
         float d = 2.75;

         UVA = (float) uv2_get_16bit(0x07);
         UVD = (float) uv2_get_16bit(0x08);
         UVB = (float) uv2_get_16bit(0x09);
         UVcomp1 = (float) uv2_get_16bit(0x0A);
         UVcomp2 = (float) uv2_get_16bit(0x0B);

         UVAcomp = ( UVA - UVD ) - a * ( UVcomp1 - UVD ) - b * ( UVcomp2 - UVD );
         UVBcomp = ( UVB - UVD ) - c * ( UVcomp1 - UVD ) - d * ( UVcomp2 - UVD );

         UVI = ( (UVBcomp * UVBresp) + (UVAcomp * UVAresp) ) / 2;

         return UVI;
}

void InitMCU()
{
   I2C1_Init( 100000 );
    Delay_ms(100);
}
void main()
{

  float uvindex = 0.0;
  char read[3];
  uint16_t read16 = 0;
  char txt[20];

  ANSELC = 0;

  Uart1_Init(9600);
  Uart1_Write_Text("Uart initialized \r\n");

  InitMCU();            // Initialize MCU

  I2C1_Start();
  I2C1_Wr(0x20);
  I2C1_Wr(0x00);
  I2C1_Wr(0x00);
  I2C1_Wr(0x00);
  I2C1_STop();

  while(1)
  {
            uvindex = get_uv_index();
            floattostr(uvindex, txt);

            Uart1_Write_Text(txt);
            Uart1_Write_Text("\r\n");

            delay_ms(500);
  }

}